/*
 * Copyright or (C) or Copr. Normandie Univ, ENSICAEN, GREYC, Caen, France
 *
 *  https://clouard.users.greyc.fr
 *
 *  This software is governed by the CeCILL-B  license under French law and
 *  abiding by the rules of distribution of free software.  You can  use,
 *  modify and/ or redistribute the software under the terms of the CeCILL-B
 *  license as circulated by CEA, CNRS and INRIA at the following URL
 *  "http://www.cecill.info".
 *
 *  In this respect, the user's attention is drawn to the risks associated
 *  with loading,  using,  modifying and/or developing or reproducing the
 *  software by the user in light of its specific status of free software,
 *  that may mean  that it is complicated to manipulate,  and  that  also
 *  therefore means  that it is reserved for developers  and  experienced
 *  professionals having in-depth computer knowledge. Users are therefore
 *  encouraged to load and test the software's suitability as regards their
 *  requirements in conditions enabling the security of their systems and/or
 *  data to be ensured and,  more generally, to use and operate it in the
 *  same conditions as regards security.
 *
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL-B license and that you accept its terms.
 */
package fr.greyc.pantheon.ariane.view.graph.element;

import fr.greyc.pantheon.ariane.ArianeSettings;
import fr.greyc.pantheon.ariane.model.graph.element.ConstantItem;
import fr.greyc.pantheon.ariane.model.graph.element.IScriptArgument;
import fr.greyc.pantheon.ariane.view.command.ChangeIsScriptArgumentValueEdit;
import fr.greyc.pantheon.ariane.view.PropertyPanel;

import java.util.ArrayList;

import javax.swing.JCheckBox;

public final class ConstantItemView extends DefaultControlElementView {
    private JCheckBox _checkBox;

    @Override
    public ArrayList<PropertyPanel.PropertyCouple> getSpecificProperties() {
        ArrayList<PropertyPanel.PropertyCouple> properties = new ArrayList<>();
        final IScriptArgument model = (ConstantItem) getModel();

        _checkBox = new JCheckBox();
        _checkBox.setSelected(model.isArgumentOfRelatedScript());
        _checkBox.addActionListener(event -> {
            model.setArgumentOfRelatedScript(((JCheckBox) event.getSource()).isSelected());
            getGraph().setModified(true);
            getGraph().validateOneAction(new ChangeIsScriptArgumentValueEdit(model, _checkBox, model.isArgumentOfRelatedScript()));
        });
        properties.add(new PropertyPanel.PropertyCouple(ArianeSettings.getString("PropertyViewer.argument"), _checkBox));
        return properties;
    }
}
