/*
 * Copyright or (C) or Copr. Normandie Univ, ENSICAEN, GREYC, Caen, France
 *
 * https://clouard.users.greyc.fr
 *
 * This software is governed by the CeCILL-B  license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL-B
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL-B license and that you accept its terms.
 */

package fr.greyc.pantheon.swingext.multivieweditor;

import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

public final class TabTitle extends JPanel {
    private final JLabel _titleLabel;

    TabTitle( final GMultiviewEditor editor, final Component component, String title ) {
        super(new FlowLayout(FlowLayout.LEFT, 0, 0));
        super.setOpaque(false);
        _titleLabel = new JLabel(title);
        _titleLabel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 5));
        super.add(_titleLabel);
        JButton closeButton;
        if (editor.getCloseIcon() != null) {
            closeButton = new JButton(editor.getCloseIcon());
        } else {
            closeButton = new JButton("X");
        }
        closeButton.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked( MouseEvent event ) {
                editor.close(component);
            }
        });
        closeButton.setOpaque(false);
        closeButton.setBorder(null);
        closeButton.setContentAreaFilled(false);
        super.add(closeButton);
    }

    public void setTitle( String title ) {
        _titleLabel.setText(title);
    }

    public String getTitle() {
        return _titleLabel.getText();
    }
}
