/*
 * Copyright or (C) or Copr. Normandie Univ, ENSICAEN, GREYC, Caen, France
 *
 * https://clouard.users.greyc.fr
 *
 * This software is governed by the CeCILL-B  license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL-B
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL-B license and that you accept its terms.
 */

package fr.greyc.pantheon.ariane;

import fr.greyc.pantheon.ariane.model.xml.XMLElement;

import java.io.File;
import java.util.Iterator;
import java.util.List;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public final class ArianeTest {

    private static Ariane _ariane;

    @BeforeAll
    public static void setUpBeforeClass() {
        _ariane = new Ariane();
    }

    @Test
    void testConfigurationFileLocalization() {
        ArianeSettings.locateConfigureFileIn(null);
        File personalOperatorFile = new File(ArianeSettings.getPersonalOperatorFilename());
        if (personalOperatorFile.exists()) {
            List<XMLElement> personalOperatorHandler = _ariane.readDefaultSettings(personalOperatorFile);

            List<XMLElement> xmlTree = personalOperatorHandler.get(0).getChildren();

            assertNotNull(xmlTree);
            Iterator<XMLElement> it = xmlTree.iterator();
            XMLElement element;
            while (it.hasNext()) {
                element = it.next();
                assertEquals("Bad operator.cfg file", element.getName(), "OperatorLibrary");
            }
        }
    }
}
